/* New Chassis Plate - because the modified one (Chassis_Rear_HK_v2) won't print. 

History:
--------
v1: Erster Wurf...alles noch sehr rudimentär, unklar, ob die Maße stimmen
v2: Batteriehalter--DONE
v3: v2 hätte gerade so aufs Druckbett gepasst. Chassis kürzer machen.
	Schraubenlöcher vom Verbinder näher an die Kante wegen Scherkräften/Hebel--DONE
v4: Verkürzen - sonst sprenge ich die 235mm Gesamtlänge.
v5: OMFG. Da passte ja fast nix (außer die Motorhalter-Löcher, und die muss ich links eh neu machen, weil der Motorhalter dem Motor im Weg ist :-) ).
v6: Batteriehalter 10mm nach vorne um Platz für den Motor zu schaffen. Posts *3.
v7: Introducing Chassis_Globals_v1.scad.
v8: Battery Lid's holes are too small.
v9: Siehe Front v9.
v10: Rear Body posts in höhe Variabel machen
v11: 6mm ist gut. Aber 10mm länger wär sinnvoll. oder gleich 15. Block kürzer.


MOTOR PASST NICHT REIN! -Axle Holder left anders???? vgl. left axle holder v4!

Löcher in BatterieHolderPosts für die zwei weiteren Posts...

ToDo:
-----
- Materialersparnisse!
- Empfängerhalter?
- ESC-Halter?


*/

/* Modules */
include <Chassis_Globals_v3.scad>;
include <../../Modules/Module_Geometrical_Objects.scad>;
include <../../Modules/Module_Really_Rounded_Cube.scad>;

/* Globals */
$fn=23;
//$fn=50;

echo("Overall length of this part: ", gBackPlateOverallLength);
echo("Wheelbase (from front): ", gBackPlateOverallLength-gAxleOffsetX);

/* Vorbereitungen fürs Kettenmaß */
lRearXMax=-gBackPlateLengthRear-10;
lRearYMax=gBackPlateWidthRear/2;
lFrontYMax=gPlateWidthFront/2;

/* (Un)Main */

/* Holes in Base Plate */
if (1)
difference()
{
	/* Base Plate */
	union()
	{
		if (1) // Plate ENABLE IF YOU WANT TO PRINT THE BASE PLATE
		{
			/* Rear part, must be narror to make room for the wheels and spur gear */
			translate([-gBackPlateLengthRear/2, 0, gPlateThickness/2])
			cube([gBackPlateLengthRear, gBackPlateWidthRear, gPlateThickness], center=true);

			/* Front part */
			translate([gBackPlateLengthFront/2, 0, gPlateThickness/2])
			cube([gBackPlateLengthFront, gPlateWidthFront, gPlateThickness], center=true);

			/* Knotenbleche */
			for (kbyi=[lRearYMax, -lRearYMax])
			translate([0, kbyi, 0])
			cylinder(d=23.0, h=gPlateThickness);

			/* Battery Tray (okay, just the borders, so the battery won't slide around */
			if (1) // Breite Version zum Deckel druffklemmen
			{
				for (btyi=[-42, 0, +42]) // Three posts
				for (btxi=[gBatteryHolderOffsetX, gBatteryHolderOffsetX+gBatterySizeWidth])
				translate([btxi, btyi, gBatterySizeHeight/2+gPlateThickness])
				{
					cube([gBatteryHolderThickness, gBatteryHolderWidth, gBatterySizeHeight], center=true);
				
					cylinder(d=gBatteryHolderThickness, h=+gBatterySizeHeight/2+5.0);
					translate([0, 0, gBatterySizeHeight/2+5])
					sphere(d=gBatteryHolderThickness);
				}
			}
				
			/*if (0) // Schmale Version
			for (btxi=[0, gBatterySizeWidth])
			translate([btxi, 0, gBatterySizeHeight/2+gPlateThickness])
			cube([gMS, 23, gBatterySizeHeight], center=true);
			/**/
		} // plate

		/* Batteriehalterdeckel, Battery Tray Lid */
		if (0) // ENABLE IF YOU WANT TO PRINT THE LID
		{
			translate([gBatteryHolderOffsetX, 0, 0])
			difference()
			{
				lBTL=gBatterySizeWidth+2*5.0;
				translate([lBTL/2-5.0/2*2, 0, 42])
				cube([lBTL, gBatteryHolderWidth, gMS], center=true);
			
				translate([0, 0, 39])
				for (btlxi=[0, gBatterySizeWidth])
				{
					#translate([btlxi, 0, 0])
					cylinder(d=6.5, h=23);
				}
			}
		}
		
		/* Rear Body Posts (Can also be printed with the whole rear plate, but then you can't vary the height/width) */
        postDia=6.0;
		postHeight=65;
		if (0) // SET TO 1 IF YOU WANT TO PRINT THE POSTS
		for (bpiy2=[-1, +1])
		translate([+5, (bpiy2*(gBackPlateBodyPostDistance)/2), gPlateThickness])
		{
			difference()
			{
				union()
				{
					translate([0, bpiy2*-6, 10/2])
					cube([10, 16, 10], center=true);
					
					//cylinder(d=10.0, h=50.0);
					cylinder(d=postDia, h=postHeight+postDia);
					translate([0, 0, postHeight+postDia])
					sphere(d=postDia);
				}
				
				/* Aussparung für Stiffener (nur bei rechteckigem Post) */
				if (0)
                translate([0, bpiy2*+gStiffenerStrength, gStiffenerStrength/2])
				cube([23, gStiffenerStrength, gStiffenerStrength], center=true); 

				/* Holes for Split Pins (Splinte) */
                for (postHoleZi=[postHeight+postDia-1:-4:23])
				translate([0, 0, postHoleZi])
				rotate([0, 90, 90])
				cylinder(d=2.0, h=23, center=true); // d=2.5 war zu gross...s
			}
		}
		
		/* Versteifungen / Verbinder */
		if (0) // ENABLE IF YOU WANT TO PRINT THE STIFFENERS
		{
			/* Versteifungen und Verbinder zu Vorderteil */
			for (vyoffsi=[-(gPlateWidthFront/2-gStiffenerStrength/2)]) //, +(gPlateWidthFront/2-gStiffenerStrength/2)])
			translate([gBackPlateStiffenerLength/2, vyoffsi, gStiffenerStrength/2+5.5])
			cube([gBackPlateStiffenerLength, gStiffenerStrength, gStiffenerStrength], center=true); 
		}	
	} // union

	/* Material saving */
		/* rear part */
		for (msryi=[-10,+10])
		translate([-gBackPlateLengthRear/2, msryi, -5])
		reallyRoundedCube(sizeX=50, sizeY=15, sizeZ=23, diameter=5);

		/* front part */
		fpmsd=gPlateWidthFront/2-20;
		fpmsdi=fpmsd*2/6;
		for (msfyi=[-fpmsd:fpmsdi:fpmsd])
		translate([+gBackPlateLengthFront/2+10, msfyi, -5])
		reallyRoundedCube(sizeX=40, sizeY=10, sizeZ=23, diameter=5);
	
	/* Holes for split pins of battery holder */
	translate([gBatteryHolderOffsetX, 0, gBatterySizeHeight+5+5/2])
	rotate([0, 90, 00])
	cylinder(d=2.0, h=230, center=true); // d=2.5 war zu gross...s
	
	/* Holes for velcro * / // TODO: Switch to posts with split pin (splint) 
	//!#rotate([00, 90, 0])
	lLangLochDia=5.0;
	if (0)
	translate([0, 0, gBatterySizeHeight-gMS])
	hull()
	for (llyi=[-gBatteryStrapWidth/2, gBatteryStrapWidth/2])
	translate([0, llyi, 0])
	rotate([0, 90, 0])
	cylinder(d=lLangLochDia, h=230, center=true);
	/* */

	
	/* Screwholes for Stiffener Mount */
	if (1)
	#for (sshyi=[ (lFrontYMax-gStiffenerStrength/2), -(lFrontYMax-gStiffenerStrength/2)])
	{	/* Hinteres Loch */
		translate([+5, sshyi, 0])
		screwHoleSunkTight();
		/* Vorderes Loch */
		translate([gBackPlateLengthFront-5, sshyi, 0])
		screwHoleSunkTight();
		/* Hinteres Loch */
		translate([gBackPlateLengthFront+gBackPlateStiffenerOverlap-5, sshyi, 0])
		screwHoleSunkTight();
		/* Vorderes Loch */
		translate([gBackPlateLengthFront+5, sshyi, 0])
		screwHoleSunkTight();
	}
	if (0)
	for (sshyi=[ (lFrontYMax-gStiffenerStrength/2), -(lFrontYMax-gStiffenerStrength/2)])
	{
		for (sshxi1=[5:25:gBackPlateLengthFront])
		{
			translate([sshxi1, sshyi, 0])
			screwHoleSunk();
		}
		for (sshxi2=[gBackPlateLengthFront+5:25:gBackPlateStiffenerLength])
		{
			translate([sshxi2, sshyi, 0])
			screwHoleSunk();
		}
	}

	/* Screwholes for right axle mount */
		/* Rear hole */
		for (rmmyi=[-lRearYMax+5.0]) //, +lRearYMax-5.0]) 
		translate([lRearXMax+26.0, rmmyi, 0])
		screwHoleSunkLoose();
	
		/* Front hole */ 
		for (fmmyi=[-lRearYMax+3.0]) //, lRearYMax+3.0]) 
		translate([lRearXMax+76.0, fmmyi, 0])
		screwHoleSunkLoose();
		
	/* Screwholes for left axle mount */
	for (lamxi=[-10, +10])
	translate([-gBackPlateLengthRear+gAxleOffsetX+lamxi, gBackPlateWidthRear/2-5, 0])
	screwHoleSunkLoose();
	
	/* Screw Holes for the Body Posts */
	if (1)
	#for (bpiy=[-1, +1])
	for (bpio=[0, 1])
	{
		translate([+5, (bpiy*(gBackPlateBodyPostDistance-bpio*10.0*2)/2), 0])
		screwHoleSunkTight();
	}
}





module screwHoleSunkLoose() // screwhole is big enough for screw, will need nut
{
	cylinder(d1=gScrewHeadCountersunkDiameter, d2=gScrewDiameterLoose, h=2.0);
	cylinder(d=gScrewDiameterLoose, h=23.23);
}

module screwHoleSunkTight() // screwhole is not big enough for screw, won't need nut
{
	cylinder(d1=gScrewHeadCountersunkDiameter, d2=gScrewDiameterTight, h=2.0);
	cylinder(d=gScrewDiameterTight, h=23.23);
}










// EOF