/* Front_Wheel_Hub 

History:
v1: Adapting Daniel's (great) design to work with ball bearings and standard 1/12th scale wheels.
v4: Die Aufnahmen für die BBs sind in v3 etwas zu klein -> +0.5
	Untere BB-Aufnahme nicht tief genug. WTF?
v5: Weil in V4 die BB-Breite nicht passt, breitr :)	Und "tiefer" unten.
v6: BB-Aufnahme jetzt e weng zu gross...also wieder -0.15 verkleinert :)
	
ToDo:
- 



*/

//$fn=23;
$fn=50;
gBBInnerDiameter=3.0; // Ball Bearings are 3x8x4
gBBOuterDiameter=8.0+0.5+0.15; // Ball Bearings are 3x8x4
gBBWidth=4.0+0.1; // Ball Bearings are 3x8x4
gAngle=18;
gBearingHousingHeight=20;
gVertOffsetFoo=2.3;
gAxleDiameter=4.0; // leave some room. The BBs will handle the right angle and location
gScrewHoleDiameterM3Min=2.8; // A M3 will fit perfectly
gHz=3.0;

difference()
{
	union()
	{
		/* Import the original Part */ 
		translate([-5, 0, 0])
		import("Front_Wheel_Hub.stl");
		
		/* Filling the holes */
		rotate([0, gAngle, 0])
		translate([0, 0, -gVertOffsetFoo])
		cylinder(d=16, h=gBearingHousingHeight);

		/* Import the original Part to add material */
		translate([0, 0, -gHz])
		linear_extrude(height=gHz) // extrude a little
		projection(cut=true)  // Make it 2D! https://gilesbathgate.com/2010/06/23/extracting-2d-mendel-outlines-using-openscad/ & https://en.wikibooks.org/wiki/OpenSCAD_User_Manual/Using_the_2D_Subsystem#3D_to_2D_Projection -> true -> schnitt durch Layer 0
		translate([-5, 0, -0.0001]) // etwas unter Z schieben für den Cut
		import("Front_Wheel_Hub.stl"); // Import the original Part 
		
	} // union

	/* Cut the lower part below Z 0    TODO    */
	if (1)
	translate([0, 0, -10/2-0.00-gHz])
	cube([50, 50, 10], center=true);

	/* Holes for BB */
	/* Lower (inner) BB  */
	
	//translate([0, 0, -0.0-gBBWidth*1]) 
	rotate([0, gAngle, 0])
	translate([0, 0, -0.0-gBBWidth*1.1]) 
	cylinder(d=gBBOuterDiameter, h=gBBWidth*2);
		/* Upper (outer) BB */
		rotate([0, gAngle, 0])
		translate([0, 0, gBearingHousingHeight-gBBWidth*1.0-gVertOffsetFoo])
		cylinder(d=gBBOuterDiameter, h=gBBWidth*2);
	
	/* Hole for axle */
	rotate([0, gAngle, 0])
	translate([0, 0, -gVertOffsetFoo])
	cylinder(d=gAxleDiameter, h=gBearingHousingHeight);

	/* Holes for wishbone link */
	rotate([0, gAngle, 0])
	translate([0, 0, 5.1])
	rotate([90, 0, 0])
	cylinder(d=gScrewHoleDiameterM3Min/2*2, h=23, center=true);
	
} //difference