/* History:

v1: Neudesign...
v2: Rounded. Nothing else.
v3: Make room for motor
v4: More room for bearing.

ToDo:

*/

//$fn=23;
$fn=50;

/* Modules */
include <../../../../../../Modules/Module_Geometrical_Objects.scad>;

/* Globals */
gAxleHolderHeight=25;
gScrewDiameterTight=2.8;
gScrewDiameterLoose=3.5;
gScrewHeadCountersunkDiameter=6.0;


difference()
{
	intersection()
	{
		translate([0, 0, gAxleHolderHeight/2])
		cube([28, 10, gAxleHolderHeight], center=true);
		
		if (0)
		#translate([-20, 0, 0])
		rotate([90, 0, 0])
		cylinder(d=42+5+5+5+10, h=23, center=true);

		translate([-0, 0, 2])
		scale([0.666, 1, 1])
		rotate([90, 0, 0])
		cylinder(d=42, h=23, center=true);
	}

	/* Room for motor */
	if (0)
	#translate([21, 0, 23/2+2.4])
	cube([23, 23, 23], center=true);
		if (0)
		#translate([21-5, 0, 3/2+2.4])
		cube([23, 23, 3], center=true);
			translate([29+0.5, 0, 36/2-3-2])
			rotate([90, 0, 0])
			cylinder(d=36+4, h=23, center=true);

	/* Room for Ball Bearing 6701 2RS 12x18x4mm */
	translate([0, -10/2+4/2, +13*1])
	rotate([90, 0, 0])
	cylinder(d=18+0.4, h=4, center=true);

	/* Room for Axle */
	translate([0, -10/2+4/2, +13*1])
	rotate([90, 0, 0])
	cylinder(d=12+1.0, h=23, center=true);
	
	/* Screwholes */
	#for(xi=[-10, +10])
	translate([xi, 0, -2.3]) 
	screwHoleSunkTight();
}


module screwHoleSunkLoose(h=23.23)
{
	cylinder(d1=gScrewHeadCountersunkDiameter, d2=gScrewDiameterLoose, h=2.0);
	cylinder(d=gScrewDiameterLoose, h=h);
}

module screwHoleSunkTight(h=23.23)
{
	cylinder(d1=gScrewHeadCountersunkDiameter, d2=gScrewDiameterTight, h=2.0);
	cylinder(d=gScrewDiameterTight, h=h);
}
